.deploy:preprod:docker-compose:
  stage: deploy
  image: registry.gitlab.com/leofy.de/docker/gitlab-builder
  extends:
    - .rules-only-release-manual
    - .tags-preprod
  dependencies:
    - prepare:template_preprod
  variables:
    SSH_HOST: 10.99.5.34
    COMPOSE_FOLDER: /opt/hebdoku-test
  environment:
    name: preprod
    url: https://test-portal.hebammen-azh.de/
  before_script:
    - echo "--> Add SSH_PRIVATE_KEY to ssh-agent"
    - eval $(ssh-agent -s)
    - echo "${SSH_PRIVATE_KEY}" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
  script:
    - echo "--> Decrypt docker-compose.yml"
    - template.py -i template_enc -o template_output -d ${TEMPLATE_ENC_KEY}
    - echo "--> Copy docker-compose.yml to destination Host"
    - scp template_output/docker-compose.yml ansible@${SSH_HOST}:${COMPOSE_FOLDER}/docker-compose.yml
    - echo "--> Restore ProdDB on PreProd"
    - ssh ansible@10.99.5.34 "cd ${COMPOSE_FOLDER}; sudo ${COMPOSE_FOLDER}/bin/restoreLatestProdDB.sh"
    - echo "--> Pull Docker images and restart containers"
    - ssh ansible@${SSH_HOST} "cd ${COMPOSE_FOLDER}; sudo docker-compose pull; sudo docker-compose down; sudo docker-compose up -d;"
    - echo "--> Execute database migration"
    - ssh ansible@${SSH_HOST} "cd ${COMPOSE_FOLDER}; sudo ${COMPOSE_FOLDER}/bin/dbmigrate.sh"
